/**
 * Copyright (c) 2000-2012 Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package it.unisef.managebooks.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.GroupedModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Book service. Represents a row in the &quot;MB_Book&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This interface and its corresponding implementation {@link it.unisef.managebooks.model.impl.BookModelImpl} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link it.unisef.managebooks.model.impl.BookImpl}.
 * </p>
 *
 * @author Giulio Piemontese
 * @see Book
 * @see it.unisef.managebooks.model.impl.BookImpl
 * @see it.unisef.managebooks.model.impl.BookModelImpl
 * @generated
 */
public interface BookModel extends BaseModel<Book>, GroupedModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this interface directly. All methods that expect a book model instance should use the {@link Book} interface instead.
	 */

	/**
	 * Returns the primary key of this book.
	 *
	 * @return the primary key of this book
	 */
	public long getPrimaryKey();

	/**
	 * Sets the primary key of this book.
	 *
	 * @param primaryKey the primary key of this book
	 */
	public void setPrimaryKey(long primaryKey);

	/**
	 * Returns the book ID of this book.
	 *
	 * @return the book ID of this book
	 */
	public long getBookId();

	/**
	 * Sets the book ID of this book.
	 *
	 * @param bookId the book ID of this book
	 */
	public void setBookId(long bookId);

	/**
	 * Returns the company ID of this book.
	 *
	 * @return the company ID of this book
	 */
	public long getCompanyId();

	/**
	 * Sets the company ID of this book.
	 *
	 * @param companyId the company ID of this book
	 */
	public void setCompanyId(long companyId);

	/**
	 * Returns the user ID of this book.
	 *
	 * @return the user ID of this book
	 */
	public long getUserId();

	/**
	 * Sets the user ID of this book.
	 *
	 * @param userId the user ID of this book
	 */
	public void setUserId(long userId);

	/**
	 * Returns the user uuid of this book.
	 *
	 * @return the user uuid of this book
	 * @throws SystemException if a system exception occurred
	 */
	public String getUserUuid() throws SystemException;

	/**
	 * Sets the user uuid of this book.
	 *
	 * @param userUuid the user uuid of this book
	 */
	public void setUserUuid(String userUuid);

	/**
	 * Returns the group ID of this book.
	 *
	 * @return the group ID of this book
	 */
	public long getGroupId();

	/**
	 * Sets the group ID of this book.
	 *
	 * @param groupId the group ID of this book
	 */
	public void setGroupId(long groupId);

	/**
	 * Returns the user name of this book.
	 *
	 * @return the user name of this book
	 */
	@AutoEscape
	public String getUserName();

	/**
	 * Sets the user name of this book.
	 *
	 * @param userName the user name of this book
	 */
	public void setUserName(String userName);

	/**
	 * Returns the create date of this book.
	 *
	 * @return the create date of this book
	 */
	public Date getCreateDate();

	/**
	 * Sets the create date of this book.
	 *
	 * @param createDate the create date of this book
	 */
	public void setCreateDate(Date createDate);

	/**
	 * Returns the modified date of this book.
	 *
	 * @return the modified date of this book
	 */
	public Date getModifiedDate();

	/**
	 * Sets the modified date of this book.
	 *
	 * @param modifiedDate the modified date of this book
	 */
	public void setModifiedDate(Date modifiedDate);

	/**
	 * Returns the title of this book.
	 *
	 * @return the title of this book
	 */
	@AutoEscape
	public String getTitle();

	/**
	 * Sets the title of this book.
	 *
	 * @param title the title of this book
	 */
	public void setTitle(String title);

	/**
	 * Returns the author of this book.
	 *
	 * @return the author of this book
	 */
	@AutoEscape
	public String getAuthor();

	/**
	 * Sets the author of this book.
	 *
	 * @param author the author of this book
	 */
	public void setAuthor(String author);

	/**
	 * Returns the description of this book.
	 *
	 * @return the description of this book
	 */
	@AutoEscape
	public String getDescription();

	/**
	 * Sets the description of this book.
	 *
	 * @param description the description of this book
	 */
	public void setDescription(String description);

	/**
	 * Returns the publisher of this book.
	 *
	 * @return the publisher of this book
	 */
	@AutoEscape
	public String getPublisher();

	/**
	 * Sets the publisher of this book.
	 *
	 * @param publisher the publisher of this book
	 */
	public void setPublisher(String publisher);

	/**
	 * Returns the pages of this book.
	 *
	 * @return the pages of this book
	 */
	public int getPages();

	/**
	 * Sets the pages of this book.
	 *
	 * @param pages the pages of this book
	 */
	public void setPages(int pages);

	/**
	 * Returns the price of this book.
	 *
	 * @return the price of this book
	 */
	public double getPrice();

	/**
	 * Sets the price of this book.
	 *
	 * @param price the price of this book
	 */
	public void setPrice(double price);

	public boolean isNew();

	public void setNew(boolean n);

	public boolean isCachedModel();

	public void setCachedModel(boolean cachedModel);

	public boolean isEscapedModel();

	public Serializable getPrimaryKeyObj();

	public void setPrimaryKeyObj(Serializable primaryKeyObj);

	public ExpandoBridge getExpandoBridge();

	public void setExpandoBridgeAttributes(ServiceContext serviceContext);

	public Object clone();

	public int compareTo(Book book);

	public int hashCode();

	public CacheModel<Book> toCacheModel();

	public Book toEscapedModel();

	public String toString();

	public String toXmlString();
}